<?php

namespace App\Controllers;

use App\Controllers\BaseController;
use App\Models\FakultasModel;

class Fakultas extends BaseController
{
    protected FakultasModel $fakultasModel;

    public function __construct()
    {
        $this->fakultasModel = new FakultasModel();
    }

    public function index()
    {
        $data = [
            'title' => 'Data Fakultas | siAkad ITKA',
            'fakultas' => $this->fakultasModel->findAll()
        ];

        return view('fakultas/index', $data);
    }

    public function create()
    {
        $data = [
            'title' => 'Tambah Data Fakultas | siAkad ITKA',
            'validation' => \Config\Services::validation()
        ];

        return view('fakultas/form', $data);
    }

    public function store()
    {
        // Validasi input
        if (!$this->validate([
            'kode_fakultas' => [
                'rules' => 'required|is_unique[fakultas.kode_fakultas]',
                'errors' => [
                    'required' => 'Kode Fakultas harus diisi.',
                    'is_unique' => 'Kode Fakultas sudah terdaftar.'
                ]
            ],
            'nama_fakultas' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Nama Fakultas harus diisi.'
                ]
            ]
        ])) {
            return redirect()->to('/fakultas/create')->withInput();
        }

        $this->fakultasModel->save([
            'kode_fakultas' => $this->request->getPost('kode_fakultas'),
            'nama_fakultas' => $this->request->getPost('nama_fakultas')
        ]);

        session()->setFlashdata('success', 'Data Fakultas berhasil ditambahkan.');
        return redirect()->to('/fakultas');
    }

    public function edit(string $id)
    {
        $data = [
            'title' => 'Edit Data Fakultas | siAkad ITKA',
            'validation' => \Config\Services::validation(),
            'fakultas' => $this->fakultasModel->find($id)
        ];

        if (empty($data['fakultas'])) {
            throw new \CodeIgniter\Exceptions\PageNotFoundException('Fakultas dengan ID ' . $id . ' tidak ditemukan');
        }

        return view('fakultas/form', $data);
    }

    public function update(string $id)
    {
        // Cek data lama untuk validasi unique
        $fakultasLama = $this->fakultasModel->find($id);
        if ($fakultasLama['kode_fakultas'] == $this->request->getPost('kode_fakultas')) {
            $rule_kode = 'required';
        } else {
            $rule_kode = 'required|is_unique[fakultas.kode_fakultas]';
        }

        if (!$this->validate([
            'kode_fakultas' => [
                'rules' => $rule_kode,
                'errors' => [
                    'required' => 'Kode Fakultas harus diisi.',
                    'is_unique' => 'Kode Fakultas sudah terdaftar.'
                ]
            ],
            'nama_fakultas' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Nama Fakultas harus diisi.'
                ]
            ]
        ])) {
            return redirect()->to('/fakultas/edit/' . $id)->withInput();
        }

        $this->fakultasModel->save([
            'id' => $id,
            'kode_fakultas' => $this->request->getPost('kode_fakultas'),
            'nama_fakultas' => $this->request->getPost('nama_fakultas')
        ]);

        session()->setFlashdata('success', 'Data Fakultas berhasil diubah.');
        return redirect()->to('/fakultas');
    }

    public function delete(string $id)
    {
        $this->fakultasModel->delete($id);
        session()->setFlashdata('success', 'Data Fakultas berhasil dihapus.');
        return redirect()->to('/fakultas');
    }
}
